Index: /code/branches/unity_build/cmake/tools/SourceFileUtilities.cmake
===================================================================
--- /code/branches/unity_build/cmake/tools/SourceFileUtilities.cmake	(revision 8557)
+++ /code/branches/unity_build/cmake/tools/SourceFileUtilities.cmake	(revision 8558)
@@ -25,8 +25,8 @@
  #                             adds the current directory.
  #                             Also compiles multiple source files into a single
- #                             one by including them
- #                             Use COMPILATION_[BEGIN|END] in
+ #                             translation unit (faster)
+ #                             Use [END_]BUILD_UNIT in
  #                             [ADD|SET]_SOURCE_FILES and specify the name of
- #                             the new source file after COMPILATION_BEGIN
+ #                             the new source file after BUILD_UNIT
  #    GET_ALL_HEADER_FILES   - Finds all header files recursively.
  #    GENERATE_SOURCE_GROUPS - Set Visual Studio source groups.
@@ -36,5 +36,5 @@
   SET(_source_files)
   FOREACH(_file ${ARGN})
-    IF(_file MATCHES "^(COMPILATION_BEGIN|COMPILATION_END)$")
+    IF(_file MATCHES "^(BUILD_UNIT|END_BUILD_UNIT)$")
       # Append keywords verbatim
       LIST(APPEND _source_files ${_file})
Index: /code/branches/unity_build/cmake/tools/TargetUtilities.cmake
===================================================================
--- /code/branches/unity_build/cmake/tools/TargetUtilities.cmake	(revision 8557)
+++ /code/branches/unity_build/cmake/tools/TargetUtilities.cmake	(revision 8558)
@@ -95,36 +95,36 @@
   PARSE_MACRO_ARGUMENTS("${_switches}" "${_list_names}" ${ARGN})
 
-  # Process source files with support for compilations
+  # Process source files with support for build units
   # Note: All file paths are relative to the root source directory, even the
-  #       name of the compilation file.
+  #       name of the build unit.
   SET(_${_target_name}_source_files)
-  SET(_get_compilation_file FALSE)
-  SET(_add_to_compilation FALSE)
+  SET(_get_build_unit_file FALSE)
+  SET(_add_to_build_unit FALSE)
   FOREACH(_file ${_arg_SOURCE_FILES})
-    IF(_file STREQUAL "COMPILATION_BEGIN")
-      # Next file is the name of the compilation
-      SET(_get_compilation_file TRUE)
-    ELSEIF(_file STREQUAL "COMPILATION_END")
-      IF(NOT _compilation_file)
-        MESSAGE(FATAL_ERROR "No name provided for source file compilation")
-      ENDIF()
-      IF(NOT DISABLE_COMPILATIONS)
-        IF(NOT _compilation_include_string)
-          MESSAGE(STATUS "Warning: Empty source file compilation!")
-        ENDIF()
-        IF(EXISTS ${_compilation_file})
-          FILE(READ ${_compilation_file} _include_string_file)
-        ENDIF()
-        IF(NOT _compilation_include_string STREQUAL "${_include_string_file}")
-          FILE(WRITE ${_compilation_file} "${_compilation_include_string}")
-        ENDIF()
-        LIST(APPEND _${_target_name}_source_files ${_compilation_file})
-      ENDIF()
-      SET(_add_to_compilation FALSE)
-    ELSEIF(_get_compilation_file)
-      SET(_compilation_file ${CMAKE_BINARY_DIR}/${_file})
-      SET(_get_compilation_file FALSE)
-      SET(_add_to_compilation TRUE)
-      SET(_compilation_include_string)
+    IF(_file STREQUAL "BUILD_UNIT")
+      # Next file is the name of the build unit
+      SET(_get_build_unit_file TRUE)
+    ELSEIF(_file STREQUAL "END_BUILD_UNIT")
+      IF(NOT _build_unit_file)
+        MESSAGE(FATAL_ERROR "No name provided for build unit")
+      ENDIF()
+      IF(NOT DISABLE_BUILD_UNITS)
+        IF(NOT _build_unit_include_string)
+          MESSAGE(STATUS "Warning: Empty build unit!")
+        ENDIF()
+        IF(EXISTS ${_build_unit_file})
+          FILE(READ ${_build_unit_file} _include_string_file)
+        ENDIF()
+        IF(NOT _build_unit_include_string STREQUAL "${_include_string_file}")
+          FILE(WRITE ${_build_unit_file} "${_build_unit_include_string}")
+        ENDIF()
+        LIST(APPEND _${_target_name}_source_files ${_build_unit_file})
+      ENDIF()
+      SET(_add_to_build_unit FALSE)
+    ELSEIF(_get_build_unit_file)
+      SET(_build_unit_file ${CMAKE_BINARY_DIR}/${_file})
+      SET(_get_build_unit_file FALSE)
+      SET(_add_to_build_unit TRUE)
+      SET(_build_unit_include_string)
     ELSE()
       # Default, add source file
@@ -146,8 +146,8 @@
       LIST(APPEND _${_target_name}_source_files ${_file})
 
-      # Handle compilations
-      IF(_add_to_compilation AND NOT DISABLE_COMPILATIONS)
+      # Handle build units
+      IF(_add_to_build_unit AND NOT DISABLE_BUILD_UNITS)
         IF(_file MATCHES "\\.(c|cc|cpp|cxx)$")
-          SET(_compilation_include_string "${_compilation_include_string}#include \"${_file}\"\n")
+          SET(_build_unit_include_string "${_build_unit_include_string}#include \"${_file}\"\n")
         ENDIF()
         # Don't compile these files, even if they are source files
Index: /code/branches/unity_build/src/CMakeLists.txt
===================================================================
--- /code/branches/unity_build/src/CMakeLists.txt	(revision 8557)
+++ /code/branches/unity_build/src/CMakeLists.txt	(revision 8558)
@@ -66,7 +66,7 @@
       ADD_LINKER_FLAGS   ("-INCREMENTAL:NO"  Debug)
     ENDIF()
-    IF(NOT DISABLE_COMPILATIONS)
-      # Compilations seem to generate 'memory leaks' with static variables
-      MESSAGE("Warning: You should disable Compilations when using VLD!")
+    IF(NOT DISABLE_BUILD_UNITS)
+      # Build units seem to generate 'memory leaks' with static variables
+      MESSAGE("Warning: You should disable build units when using VLD!")
     ENDIF()
   ENDIF()
Index: /code/branches/unity_build/src/OrxonoxConfig.cmake
===================================================================
--- /code/branches/unity_build/src/OrxonoxConfig.cmake	(revision 8557)
+++ /code/branches/unity_build/src/OrxonoxConfig.cmake	(revision 8558)
@@ -35,5 +35,5 @@
 
 # Global switch to disable multiple file compilations
-OPTION(DISABLE_COMPILATIONS "Global multi-file compilation switch" FALSE)
+OPTION(DISABLE_BUILD_UNITS "Disables building multiple source files as one." FALSE)
 
 # Use WinMain() or main()?
Index: /code/branches/unity_build/src/external/bullet/BulletCollision/CMakeLists.txt
===================================================================
--- /code/branches/unity_build/src/external/bullet/BulletCollision/CMakeLists.txt	(revision 8557)
+++ /code/branches/unity_build/src/external/bullet/BulletCollision/CMakeLists.txt	(revision 8558)
@@ -1,5 +1,5 @@
 ADD_SOURCE_FILES(BULLET_FILES
 
-COMPILATION_BEGIN BulletCollisionCompilation.cpp
+BUILD_UNIT BulletCollisionBuildUnit.cpp
 
 	BroadphaseCollision/btAxisSweep3.cpp
@@ -88,7 +88,7 @@
 	NarrowPhaseCollision/btVoronoiSimplexSolver.cpp
 
-COMPILATION_END
+END_BUILD_UNIT
 
-    # Raises compiler errors when compiled inside the compilation
+    # Raises compiler errors when compiled inside the build unit
 	NarrowPhaseCollision/btPolyhedralContactClipping.cpp
 
Index: /code/branches/unity_build/src/external/bullet/BulletDynamics/CMakeLists.txt
===================================================================
--- /code/branches/unity_build/src/external/bullet/BulletDynamics/CMakeLists.txt	(revision 8557)
+++ /code/branches/unity_build/src/external/bullet/BulletDynamics/CMakeLists.txt	(revision 8558)
@@ -1,5 +1,5 @@
 ADD_SOURCE_FILES(BULLET_FILES
 
-COMPILATION_BEGIN BulletDynamicsCompilation.cpp
+BUILD_UNIT BulletDynamicsBuildUnit.cpp
 
 	Character/btKinematicCharacterController.cpp
@@ -26,5 +26,5 @@
 	Vehicle/btWheelInfo.cpp
 
-COMPILATION_END
+END_BUILD_UNIT
 
 	# Headers
Index: /code/branches/unity_build/src/external/bullet/LinearMath/CMakeLists.txt
===================================================================
--- /code/branches/unity_build/src/external/bullet/LinearMath/CMakeLists.txt	(revision 8557)
+++ /code/branches/unity_build/src/external/bullet/LinearMath/CMakeLists.txt	(revision 8558)
@@ -1,12 +1,12 @@
 ADD_SOURCE_FILES(BULLET_FILES
 
-COMPILATION_BEGIN BulletLinearMathCompilation.cpp
+BUILD_UNIT BulletLinearMathBuildUnit.cpp
 	btAlignedAllocator.cpp
 	btConvexHull.cpp
-    btConvexHullComputer.cpp
+	btConvexHullComputer.cpp
 	btGeometryUtil.cpp
 	btQuickprof.cpp
 	btSerializer.cpp
-COMPILATION_END
+END_BUILD_UNIT
 
 	# Headers
@@ -15,5 +15,5 @@
 	btAlignedObjectArray.h
 	btConvexHull.h
-    btConvexHullComputer.h
+	btConvexHullComputer.h
 	btDefaultMotionState.h
 	btGeometryUtil.h
Index: /code/branches/unity_build/src/external/enet/CMakeLists.txt
===================================================================
--- /code/branches/unity_build/src/external/enet/CMakeLists.txt	(revision 8557)
+++ /code/branches/unity_build/src/external/enet/CMakeLists.txt	(revision 8558)
@@ -29,5 +29,5 @@
     win32.h
 
-COMPILATION_BEGIN ENetCompilation.c
+BUILD_UNIT ENetBuildUnit.c
     callbacks.c
     compress.c
@@ -39,5 +39,5 @@
     unix.c
     win32.c
-COMPILATION_END
+END_BUILD_UNIT
 )
 
Index: /code/branches/unity_build/src/external/ogreceguirenderer/CMakeLists.txt
===================================================================
--- /code/branches/unity_build/src/external/ogreceguirenderer/CMakeLists.txt	(revision 8557)
+++ /code/branches/unity_build/src/external/ogreceguirenderer/CMakeLists.txt	(revision 8558)
@@ -23,9 +23,9 @@
   OgreCEGUITexture.h
 
-COMPILATION_BEGIN OgreCEGUIRendererCompilation.cpp
+BUILD_UNIT OgreCEGUIRendererBuildUnit.cpp
   OgreCEGUIRenderer.cpp
   OgreCEGUIResourceProvider.cpp
   OgreCEGUITexture.cpp
-COMPILATION_END
+END_BUILD_UNIT
 )
 
Index: /code/branches/unity_build/src/external/ois/CMakeLists.txt
===================================================================
--- /code/branches/unity_build/src/external/ois/CMakeLists.txt	(revision 8557)
+++ /code/branches/unity_build/src/external/ois/CMakeLists.txt	(revision 8558)
@@ -35,5 +35,5 @@
   OISPrereqs.h
 
-#COMPILATION_BEGIN OISCompilation.cpp
+#BUILD_UNIT OISBuildUnit.cpp
   OISEffect.cpp
   OISException.cpp
@@ -43,5 +43,5 @@
   OISKeyboard.cpp
   OISObject.cpp
-#COMPILATION_END
+#END_BUILD_UNIT
 )
 IF(WIN32)
Index: /code/branches/unity_build/src/external/ois/linux/CMakeLists.txt
===================================================================
--- /code/branches/unity_build/src/external/ois/linux/CMakeLists.txt	(revision 8557)
+++ /code/branches/unity_build/src/external/ois/linux/CMakeLists.txt	(revision 8558)
@@ -8,5 +8,5 @@
   LinuxPrereqs.h
 
-COMPILATION_BEGIN OISLinuxCompilation.cpp
+BUILD_UNIT OISLinuxBuildUnit.cpp
   EventHelpers.cpp
   LinuxForceFeedback.cpp
@@ -15,4 +15,4 @@
   LinuxKeyboard.cpp
   LinuxMouse.cpp
-COMPILATION_END
+END_BUILD_UNIT
 )
Index: /code/branches/unity_build/src/external/ois/mac/CMakeLists.txt
===================================================================
--- /code/branches/unity_build/src/external/ois/mac/CMakeLists.txt	(revision 8557)
+++ /code/branches/unity_build/src/external/ois/mac/CMakeLists.txt	(revision 8558)
@@ -8,5 +8,5 @@
   MacPrereqs.h
 
-#COMPILATION_BEGIN OISMacCompilation.cpp
+#BUILD_UNIT OISMacBuildUnit.cpp
   MacHelpers.cpp
   MacHIDManager.cpp
@@ -15,4 +15,4 @@
   MacKeyboard.cpp
   MacMouse.cpp
-#COMPILATION_END
+#END_BUILD_UNIT
 )
Index: /code/branches/unity_build/src/external/ois/win32/CMakeLists.txt
===================================================================
--- /code/branches/unity_build/src/external/ois/win32/CMakeLists.txt	(revision 8557)
+++ /code/branches/unity_build/src/external/ois/win32/CMakeLists.txt	(revision 8558)
@@ -7,5 +7,5 @@
   Win32Prereqs.h
 
-COMPILATION_BEGIN OISWin32Compilation.cpp
+BUILD_UNIT OISWin32BuildUnit.cpp
   Win32ForceFeedback.cpp
   Win32InputManager.cpp
@@ -13,4 +13,4 @@
   Win32KeyBoard.cpp
   Win32Mouse.cpp
-COMPILATION_END
+END_BUILD_UNIT
 )
Index: /code/branches/unity_build/src/external/tinyxml/CMakeLists.txt
===================================================================
--- /code/branches/unity_build/src/external/tinyxml/CMakeLists.txt	(revision 8557)
+++ /code/branches/unity_build/src/external/tinyxml/CMakeLists.txt	(revision 8558)
@@ -24,5 +24,5 @@
   tinyxml.h
 
-COMPILATION_BEGIN TicppCompilation.cpp
+BUILD_UNIT TicppBuildUnit.cpp
   ticpp.cpp
   tinystr.cpp
@@ -30,5 +30,5 @@
   tinyxmlerror.cpp
   tinyxmlparser.cpp
-COMPILATION_END
+END_BUILD_UNIT
 )
 
Index: /code/branches/unity_build/src/libraries/core/CMakeLists.txt
===================================================================
--- /code/branches/unity_build/src/libraries/core/CMakeLists.txt	(revision 8557)
+++ /code/branches/unity_build/src/libraries/core/CMakeLists.txt	(revision 8558)
@@ -49,22 +49,22 @@
   XMLPort.cc
 
-COMPILATION_BEGIN ListenerCompilation.cc
+BUILD_UNIT ListenerBuildUnit.cc
   ViewportEventListener.cc
   WindowEventListener.cc
   XMLNameListener.cc
-COMPILATION_END
+END_BUILD_UNIT
 
-COMPILATION_BEGIN FilesystemCompilation.cc
+BUILD_UNIT FilesystemBuildUnit.cc
   command/ArgumentCompletionFunctions.cc
   ConfigFileManager.cc
   PathConfig.cc
-COMPILATION_END
+END_BUILD_UNIT
 
   # multithreading
   ThreadPool.cc
-COMPILATION_BEGIN ThreadCompilation.cc
+BUILD_UNIT ThreadBuildUnit.cc
   command/TclThreadManager.cc
   Thread.cc
-COMPILATION_END
+END_BUILD_UNIT
 )
 
Index: /code/branches/unity_build/src/libraries/network/packet/CMakeLists.txt
===================================================================
--- /code/branches/unity_build/src/libraries/network/packet/CMakeLists.txt	(revision 8557)
+++ /code/branches/unity_build/src/libraries/network/packet/CMakeLists.txt	(revision 8558)
@@ -1,4 +1,5 @@
 ADD_SOURCE_FILES(NETWORK_SRC_FILES
-COMPILATION_BEGIN PacketCompilation.cc
+
+BUILD_UNIT PacketBuildUnit.cc
   Acknowledgement.cc
   Chat.cc
@@ -10,5 +11,6 @@
   Packet.cc
   Welcome.cc
-COMPILATION_END
+END_BUILD_UNIT
+
   ServerInformation.cc
 )
Index: /code/branches/unity_build/src/libraries/tools/CMakeLists.txt
===================================================================
--- /code/branches/unity_build/src/libraries/tools/CMakeLists.txt	(revision 8557)
+++ /code/branches/unity_build/src/libraries/tools/CMakeLists.txt	(revision 8558)
@@ -1,10 +1,13 @@
 SET_SOURCE_FILES(TOOLS_SRC_FILES
-COMPILATION_BEGIN ResourceCompilation.cc
+
+BUILD_UNIT ResourceBuildUnit.cc
   ResourceCollection.cc
   ResourceLocation.cc
-COMPILATION_END
+END_BUILD_UNIT
+
   TextureGenerator.cc
   Timer.cc
-COMPILATION_BEGIN OgreCompilation.cc
+
+BUILD_UNIT OgreBuildUnit.cc
   BillboardSet.cc
   DynamicLines.cc
@@ -13,6 +16,7 @@
   ParticleInterface.cc
   Shader.cc
-COMPILATION_END
+END_BUILD_UNIT
 )
+
 #ADD_SUBDIRECTORY(bsp)
 ADD_SUBDIRECTORY(interfaces)
Index: /code/branches/unity_build/src/libraries/util/CMakeLists.txt
===================================================================
--- /code/branches/unity_build/src/libraries/util/CMakeLists.txt	(revision 8557)
+++ /code/branches/unity_build/src/libraries/util/CMakeLists.txt	(revision 8558)
@@ -19,5 +19,6 @@
 
 SET_SOURCE_FILES(UTIL_SRC_FILES
-COMPILATION_BEGIN StableCompilation.cc
+
+BUILD_UNIT StableBuildUnit.cc
   Clipboard.cc
   Clock.cc
@@ -32,5 +33,5 @@
   SmallObjectAllocator.cc
   SubString.cc
-COMPILATION_END
+END_BUILD_UNIT
 
   MultiType.cc
Index: /code/branches/unity_build/src/modules/pong/CMakeLists.txt
===================================================================
--- /code/branches/unity_build/src/modules/pong/CMakeLists.txt	(revision 8557)
+++ /code/branches/unity_build/src/modules/pong/CMakeLists.txt	(revision 8558)
@@ -1,4 +1,4 @@
 SET_SOURCE_FILES(PONG_SRC_FILES
-COMPILATION_BEGIN PongCompilation.cc
+BUILD_UNIT PongBuildUnit.cc
   Pong.cc
   PongAI.cc
@@ -8,5 +8,5 @@
   PongCenterpoint.cc
   PongScore.cc
-COMPILATION_END
+END_BUILD_UNIT
 )
 
Index: /code/branches/unity_build/src/orxonox/CMakeLists.txt
===================================================================
--- /code/branches/unity_build/src/orxonox/CMakeLists.txt	(revision 8557)
+++ /code/branches/unity_build/src/orxonox/CMakeLists.txt	(revision 8558)
@@ -35,8 +35,9 @@
   ChatInputHandler.cc
 #  Test.cc
-COMPILATION_BEGIN SceneCompilation.cc
+
+BUILD_UNIT SceneBuildUnit.cc
   CameraManager.cc
   Scene.cc
-COMPILATION_END
+END_BUILD_UNIT
 )
 
Index: /code/branches/unity_build/src/orxonox/graphics/CMakeLists.txt
===================================================================
--- /code/branches/unity_build/src/orxonox/graphics/CMakeLists.txt	(revision 8557)
+++ /code/branches/unity_build/src/orxonox/graphics/CMakeLists.txt	(revision 8558)
@@ -9,8 +9,9 @@
   ParticleEmitter.cc
   ParticleSpawner.cc
-COMPILATION_BEGIN GraphicsCompilation.cc
+
+BUILD_UNIT GraphicsBuildUnit.cc
   Backlight.cc
   Camera.cc
   Light.cc
-COMPILATION_END
+END_BUILD_UNIT
 )