Index: /branches/gui/src/lib/gui/gl/glgui_style.cc
===================================================================
--- /branches/gui/src/lib/gui/gl/glgui_style.cc	(revision 8558)
+++ /branches/gui/src/lib/gui/gl/glgui_style.cc	(revision 8559)
@@ -26,5 +26,6 @@
   /**
    * @brief standard constructor
-  */
+   * @param root the XML-Element to load settings from
+   */
   GLGuiStyle::GLGuiStyle (const TiXmlElement* root)
   {
@@ -47,4 +48,7 @@
   }
 
+  /**
+   * @brief resets the Style to the default Settings.
+   */
   void GLGuiStyle::reset()
   {
@@ -65,4 +69,8 @@
   }
 
+  /**
+   * @brief loads Parameters for a Style from XML
+   * @param root the XML-Element to load from.
+   */
   void GLGuiStyle::loadParams(const TiXmlElement* root)
   {
@@ -76,5 +84,5 @@
     LoadParam(root, "foreground-color", this, GLGuiStyle, setForegroundColorS);
 
-    LoadParam(root, "feature-position", this, GLGuiStyle, setFeaturePosition);
+    LoadParam(root, "feature-position", this, GLGuiStyle, setFeaturePositionS);
     LoadParam(root, "Font", this, GLGuiStyle, setFont);
 
@@ -83,5 +91,8 @@
   }
 
-
+  /**
+   * @brief sets the Width of the left border for all States
+   * @param value the borderWidth
+   */
   void GLGuiStyle::setBorderLeft(float value)
   {
@@ -90,4 +101,9 @@
   }
 
+  /**
+   * @brief sets the Width of the left border.
+   * @param value the borderWidth
+   * @param state the State to set the borderwidth to
+   */
   void GLGuiStyle::setBorderLeft(float value, OrxGui::State state)
   {
@@ -95,4 +111,9 @@
   }
 
+  /**
+   * @brief sets the Width of the left border.
+   * @param value the borderWidth
+   * @param stateName the State to set the borderwidth to
+   */
   void GLGuiStyle::setBorderLeftS(float value, const std::string& stateName)
   {
@@ -104,5 +125,8 @@
   }
 
-
+  /**
+   * @brief sets the Width of the right border for all states.
+   * @param value the borderWidth
+   */
   void GLGuiStyle::setBorderRight(float value)
   {
@@ -111,4 +135,9 @@
   }
 
+  /**
+   * @brief sets the Width of the right border.
+   * @param value the borderWidth
+   * @param state the State to setup.
+   */
   void GLGuiStyle::setBorderRight(float value, OrxGui::State state)
   {
@@ -116,4 +145,9 @@
   }
 
+  /**
+   * @brief sets the Width of the right border.
+   * @param value the borderWidth
+   * @param stateName the State to setup.
+   */
   void GLGuiStyle::setBorderRightS(float value, const std::string& stateName)
   {
@@ -126,4 +160,8 @@
 
 
+  /**
+   * @brief sets the Width of the top border for all states.
+   * @param value the borderWidth
+   */
   void GLGuiStyle::setBorderTop(float value)
   {
@@ -132,4 +170,9 @@
   }
 
+  /**
+   * @brief sets the Width of the top border.
+   * @param value the borderWidth
+   * @param state the State to setup.
+   */
   void GLGuiStyle::setBorderTop(float value, OrxGui::State state)
   {
@@ -137,4 +180,9 @@
   }
 
+  /**
+   * @brief sets the Width of the top border.
+   * @param value the borderWidth
+   * @param stateName the State to setup.
+   */
   void GLGuiStyle::setBorderTopS(float value, const std::string& stateName)
   {
@@ -147,4 +195,8 @@
 
 
+  /**
+   * @brief sets the Width of the bottom border for all states.
+   * @param value the borderWidth
+   */
   void GLGuiStyle::setBorderBottom(float value)
   {
@@ -153,4 +205,9 @@
   }
 
+  /**
+   * @brief sets the Width of the bottom border.
+   * @param value the borderWidth
+   * @param state the State to setup.
+   */
   void GLGuiStyle::setBorderBottom(float value, OrxGui::State state)
   {
@@ -158,14 +215,23 @@
   }
 
+  /**
+   * @brief sets the Width of the bottom border for all states.
+   * @param value the borderWidth
+   * @param stateName the State to setup.
+   */
   void GLGuiStyle::setBorderBottomS(float value, const std::string& stateName)
   {
-        OrxGui::State state;
-  if (getState(stateName, &state))
-    this->setBorderBottom(value, state);
-  else
-    this->setBorderBottom(value);
-  }
-
-
+    OrxGui::State state;
+    if (getState(stateName, &state))
+      this->setBorderBottom(value, state);
+    else
+      this->setBorderBottom(value);
+  }
+
+
+  /**
+   * @brief sets the TextSize for all states.
+   * @param value the TextSize
+   */
   void GLGuiStyle::setTextSize(float value)
   {
@@ -174,4 +240,9 @@
   }
 
+  /**
+   * @brief sets the TextSize.
+   * @param value the TextSize.
+   * @param state: the State to setup
+   */
   void GLGuiStyle::setTextSize(float value, OrxGui::State state)
   {
@@ -179,4 +250,9 @@
   }
 
+  /**
+   * @brief sets the TextSize.
+   * @param value the TextSize.
+   * @param stateName: the State to setup
+   */
   void GLGuiStyle::setTextSizeS(float value, const std::string& stateName)
   {
@@ -189,4 +265,8 @@
 
 
+  /**
+   * @brief sets the Background Color for all States.
+   * @param color the Color.
+   */
   void GLGuiStyle::setBackgroundColor(const Color& color)
   {
@@ -195,4 +275,9 @@
   }
 
+  /**
+   * @brief sets the Background Color.
+   * @param color the Color.
+   * @param state: the State to setup
+   */
   void GLGuiStyle::setBackgroundColor(const Color& color, OrxGui::State state)
   {
@@ -200,4 +285,12 @@
   }
 
+  /**
+   * @brief sets the Background Color.
+   * @param r the Color's red part.
+   * @param g the Color's green part.
+   * @param b the Color's blue part.
+   * @param a the Color's alpha part.
+   * @param stateName: the State to setup
+   */
   void GLGuiStyle::setBackgroundColorS(float r, float g, float b, float a, const std::string& stateName)
   {
@@ -210,4 +303,8 @@
 
 
+  /**
+   * @brief sets the Background Texture for all States.
+   * @param texture the Texture.
+   */
   void GLGuiStyle::setBackgroundTexture(const Texture& texture)
   {
@@ -216,4 +313,9 @@
   }
 
+  /**
+   * @brief sets the Background Texture.
+   * @param texture the Texture.
+   * @param state the State to setup.
+   */
   void GLGuiStyle::setBackgroundTexture(const Texture& texture, OrxGui::State state)
   {
@@ -221,14 +323,23 @@
   }
 
+  /**
+   * @brief sets the Background Texture.
+   * @param texture the Texture.
+   * @param stateName the State to setup.
+   */
   void GLGuiStyle::setBackgroundTexture(const std::string& textureName, const std::string& stateName)
   {
-        OrxGui::State state;
-  if (getState(stateName, &state))
-    ; /// FIXME this->setBackgroundTexture(textureName, state);
-  else
+    OrxGui::State state;
+    if (getState(stateName, &state))
+      ; /// FIXME this->setBackgroundTexture(textureName, state);
+    else
       ; ///    this->setBackgroundTexture(textureName);
   }
 
 
+  /**
+   * @brief sets the Foreground Color for all States.
+   * @param color the Color.
+   */
   void GLGuiStyle::setForegroundColor(const Color& color)
   {
@@ -237,4 +348,9 @@
   }
 
+  /**
+   * @brief sets the Foreground Color.
+   * @param color the Color.
+   * @param state the State to setup
+   */
   void GLGuiStyle::setForegroundColor(const Color& color, OrxGui::State state)
   {
@@ -242,4 +358,12 @@
   }
 
+  /**
+   * @brief sets the Foreground Color.
+   * @param r the Color's red part.
+   * @param g the Color's green part.
+   * @param b the Color's blue part.
+   * @param a the Color's alpha part.
+   * @param stateName: the State to setup
+   */
   void GLGuiStyle::setForegroundColorS(float r, float g, float b, float a, const std::string& stateName)
   {
@@ -252,5 +376,8 @@
 
 
-
+  /**
+   * @brief sets the Feature-Position.
+   * @param featurePosition the Feature-Position.
+   */
   void GLGuiStyle::setFeaturePosition(FeaturePosition featurePosition)
   {
@@ -258,5 +385,9 @@
   }
 
-  void GLGuiStyle::setFeaturePosition(const std::string& featurePosition)
+  /**
+   * @brief sets the Feature-Position by converting from a String.
+   * @param featurePosition the Feature-Position.
+   */
+  void GLGuiStyle::setFeaturePositionS(const std::string& featurePosition)
   {
     for (unsigned int i = 0; i < 4; ++i)
@@ -269,4 +400,8 @@
   }
 
+  /**
+   * @brief sets the Font.
+   * @param font the Font.
+   */
   void GLGuiStyle::setFont(Font* font)
   {
@@ -274,4 +409,8 @@
   }
 
+  /**
+   * @brief sets the font from a Font-Name.
+   * @param fontName the FileName of the Font.
+   */
   void GLGuiStyle::setFont(const std::string& fontName)
   {
@@ -279,5 +418,8 @@
   }
 
-
+  /**
+   * @brief if Animation should be turned on.
+   * @param animated true if on, false otherwise.
+   */
   void GLGuiStyle::setAnimated(bool animated)
   {
@@ -285,4 +427,8 @@
   }
 
+  /**
+   * @brief sets the AnimatedState.
+   * @param animated: it states-changes should animate true, otherwise false.
+   */
   void GLGuiStyle::setAnimatedStateChanges(bool animated)
   {
@@ -291,15 +437,18 @@
 
 
-
+  /**
+   * @param stateName the Name of a State.
+   * @param state the found State is returned here if found.
+   * @returns true if String is found, false otherwise.
+   */
   bool GLGuiStyle::getState(const std::string& stateName, OrxGui::State* state)
   {
     for (unsigned int i = 0; i < GLGUI_STATE_COUNT; ++i)
       if (stateName == OrxGui::StateString[i])
-    {
-      *state = (OrxGui::State)i;
+      {
+        *state = (OrxGui::State)i;
         return true;
-    }
+      }
     return false;
   }
-
 }
Index: /branches/gui/src/lib/gui/gl/glgui_style.h
===================================================================
--- /branches/gui/src/lib/gui/gl/glgui_style.h	(revision 8558)
+++ /branches/gui/src/lib/gui/gl/glgui_style.h	(revision 8559)
@@ -26,16 +26,28 @@
 
     /// Retrieve
+    /** @returns left borderWidth @param state the State to retrieve from */
     inline float borderLeft(OrxGui::State state = GLGUI_DEFAULT_STYLE) const { return _style[state]._borderLeft; }
+    /** @returns right borderWidth @param state the State to retrieve from */
     inline float borderRight(OrxGui::State state = GLGUI_DEFAULT_STYLE) const { return _style[state]._borderRight; }
+    /** @returns top borderWidth @param state the State to retrieve from */
     inline float borderTop(OrxGui::State state = GLGUI_DEFAULT_STYLE) const { return _style[state]._borderTop; }
+    /** @returns bottom borderWidth @param state the State to retrieve from */
     inline float borderBottom(OrxGui::State state = GLGUI_DEFAULT_STYLE) const { return _style[state]._borderBottom; }
+    /** @returns textSize @param state the State to retrieve from */
     inline float textSize(OrxGui::State state = GLGUI_DEFAULT_STYLE) const { return _style[state]._textSize; }
+    /** @returns the Background Color @param state the State to retrieve from */
     inline const Color& backgroundColor(OrxGui::State state= GLGUI_DEFAULT_STYLE) const { return _style[state]._backgroundColor; }
+    /** @returns background Texture. @param state the State to retrieve from */
     inline const Texture& backgrorundTexture(OrxGui::State state= GLGUI_DEFAULT_STYLE) const { return _style[state]._backgroundTexture; }
+    /** @returns the foreground Color @param state the State to retrieve from */
     inline const Color& foregroundColor(OrxGui::State state= GLGUI_DEFAULT_STYLE) const { return _style[state]._foregroundColor; }
 
+    /** @returns FeaturePosition */
     inline FeaturePosition featurePosition() const { return _featurePosition; }
+    /** @returns the font */
     inline const Font* const font() const { return _font; }
+    /** @returns true if the Element is Animated */
     inline bool animated() const { return _animated; }
+    /** @returns true if State-Changes are animated */
     inline bool animatedStateChanges() const { return _animatedStateChanges; }
 
@@ -80,5 +92,5 @@
 
     void setFeaturePosition(FeaturePosition featurePosition);
-    void setFeaturePosition(const std::string& featurePosition);
+    void setFeaturePositionS(const std::string& featurePosition);
 
     void setFont(Font* font);
@@ -109,5 +121,5 @@
 
 
-    StatedStyle         _style[GLGUI_STATE_COUNT];
+    StatedStyle         _style[GLGUI_STATE_COUNT]; //!< Styles configured for different States
 
     FeaturePosition     _featurePosition;      //!< The Position a Feature will be layed at (checkbox(box), slider(text),...)